package sample.lightbox.abdbupdate;

import android.util.Log;
import android.view.View;
import android.widget.EditText;

import com.google.gson.Gson;

import java.util.HashMap;
import java.util.Map;

import sample.lightbox.abdbupdate.databinding.ActivityMainBinding;


// *************************************************
// ボタンイベント処理用クラス
// *************************************************
public class ButtonAction implements View.OnClickListener {

	// エミュレータ用
	private String webPage1 = "http://10.0.2.2/atest/dbdata_get_json.php";
	private String webPage2 = "http://10.0.2.2/atest/dbdata_update_json.php";
	// WiFi 実機用( 192.168.1.2 は 自分の PC の IP アドレスに書き換えます )
//	private String webPage1 = "http://192.168.1.2/atest/dbdata_get_json.php";
//	private String webPage2 = "http://192.168.1.2/atest/dbdata_update_json.php";

	// 固定データ
	private MainActivity context = null;
	// 処理毎に変化するデータ
	private Syain syain = null;
	private ActivityMainBinding binding = null;

	// コンストラクタ( 固定データのセット )
	public ButtonAction( MainActivity context) {
		this.context = context;
	}

	// 画面バインド用データ( 処理毎に変化するデータのセット )
	public void setData(ActivityMainBinding binding) {
		this.binding = binding;
	}

	@Override
	public void onClick(View v) {

		// *************************************************
		// 読み出し
		// *************************************************
		if (v.getId() == R.id.getData) {

			String scode = ((EditText) context.findViewById(R.id.editScode)).getText().toString();
			Map map = new HashMap();
			map.put("scode", scode);

			Tools1114.callHttpGet(
					"http://192.168.1.2/atest/dbdata_get_json.php",
					"utf-8",
					map,
					new Tools1114.OnAsyncTaskListener() {
						@Override
						public void onAsyncTaskListener(String s) {

							Log.i("lightbox", s);

							Gson gson = new Gson();
							syain = gson.fromJson(s,Syain.class);
							binding.setUser(syain);

							Tools1114.setFocusNoKeyboard(context, R.id.editKj);

						}
					}
			);

		}

		// *************************************************
		// 更新
		// *************************************************
		if (v.getId() == R.id.updateData) {

			// 更新用転送
			syain = new Syain();
			syain.scode = ((EditText)context.findViewById(R.id.editScode)).getText().toString();
			syain.kj = ((EditText)context.findViewById(R.id.editKj)).getText().toString();
			syain.furi = ((EditText)context.findViewById(R.id.editFuri)).getText().toString();

			Gson gson = new Gson();
			String json = gson.toJson(syain);

			Map map = new HashMap();
			map.put("sdata", json);

			Tools1114.callHttpGet(
					"http://192.168.1.2/atest/dbdata_update_json.php",
					"utf-8",
					map,
					new Tools1114.OnAsyncTaskListener() {
						@Override
						public void onAsyncTaskListener(String s) {

							Log.i("lightbox", s);

							Gson gson = new Gson();
							syain = gson.fromJson(s,Syain.class);

							syain.kj = "";
							syain.furi = "";
							binding.setUser(syain);

							// フォーカスを社員コードへ
							Tools1114.setFocusNoKeyboard(context, R.id.editScode);

						}
					}
			);

		}

	}
}
