package sample.lightbox.abdbupdate;

import android.content.Context;
import android.os.AsyncTask;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Iterator;
import java.util.Map;

/**
 * Created by lightbox on 2015/11/14.
 */
public class Tools1114 {

	public static void setFocusNoKeyboard( MainActivity context, int id ) {

		// フォーカス
		EditText et  = (EditText) context.findViewById(id);
		et.requestFocus();

		// ソフトウェアキーボードを閉じる
		InputMethodManager im;
		im = (InputMethodManager)context.getSystemService(Context.INPUT_METHOD_SERVICE);
		im.hideSoftInputFromWindow(et.getWindowToken(), InputMethodManager.HIDE_NOT_ALWAYS);

	}


	// 指定した URL へ 任意の charset で処理
	public static String httpGet(String targetUrl, String targetCharset, Map<String, String> params) {

		StringBuffer web_data = new StringBuffer();

		try {
			// Query String の作成( 必要無ければ引数を null とする )
			String data = "";
			if (params != null) {
				Iterator<String> it = params.keySet().iterator();
				String key = null;
				String value = null;
				while (it.hasNext()) {
					key = it.next().toString();
					value = params.get(key);
					if (!data.equals("")) {
						data += "&";
					}
					data += key + "=" + URLEncoder.encode(value, targetCharset);
				}
				if (!data.equals("")) {
					targetUrl = targetUrl + "?" + data;
				}
			}

			// **********************************************
			// インターネットへの接続
			// **********************************************
			// 読み込む WEB上のターゲット
			URL url = new URL(targetUrl);
			// 接続オブジェクト
			HttpURLConnection http = (HttpURLConnection) url.openConnection();
			// GET メソッド
			http.setRequestMethod("GET");
			// 接続
			http.connect();

			// **********************************************
			// ストリームとして読み込む準備
			// **********************************************
			// 以下読み込み３点セット InputStream / InputStreamReader / BufferedReader
			InputStream input_stream = http.getInputStream();
			// UTF-8 でリーダーを作成
			InputStreamReader input_stream_reader = new InputStreamReader(input_stream, targetCharset);
			// 行単位で読み込む為の準備
			BufferedReader buffered_reader = new BufferedReader(input_stream_reader);

			// **********************************************
			// 行の一括読み込み
			// **********************************************
			String line_buffer = null;
			// BufferedReader は、readLine が null を返すと読み込み終了
			while (null != (line_buffer = buffered_reader.readLine())) {
				web_data.append(line_buffer);
				web_data.append("\n");
			}

			// **********************************************
			// 接続解除
			// **********************************************
			http.disconnect();
		} catch (Exception e) {
			// 失敗
			System.out.println(e.toString());
		}
		return web_data.toString();
	}

	public interface OnAsyncTaskListener {
		abstract public void onAsyncTaskListener(String s);
	}

	public static void callHttpGet(String url, String charset, final Map<String, String> qparams, final OnAsyncTaskListener listener) {
		new AsyncTask<String, Void, String>() {

			// 非同期処理
			@Override
			protected String doInBackground(String... params) {
				String result = null;
				result =
						Tools1114.httpGet(
								params[0],
								params[1],
								qparams
						);

				return result;
			}

			// UI スレッド処理
			@Override
			protected void onPostExecute(String json) {
				super.onPostExecute(json);

				listener.onAsyncTaskListener(json);

			}
		}.execute(url, charset);
	}

}
